*
      SUBROUTINE PAZ_TRSV( NAME, N, NPROCS, MMIN, NB )
*
*        NB  
*          PZDTSV, PZPTSV
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROCS, MMIN, NB
      CHARACTER*(*)      NAME
*
*   -  
      INTEGER           NPR
      PARAMETER         ( NPR = 6 )
*
*  
      INTEGER            CTXT, I, IAM, IPA, IPB, IPW, IPWOR,
     $                   IPD, IPDL, IPDU, IPE, 
     $                   NP, NQ, NQRHS, NRHS, NB0, WORKSIZ,
     $                   LWORK, NPROW, NPCOL
*
*  
*
*  
*
*    NB  
*    NPROW, NPCOL
*
      NPROW = 1
      NPCOL = NPROCS
*
      NB0 = INT(REAL( N/NPROCS ))
* + 1
      IF( NB0.LE.2 ) GO TO 10
      NB = NB0
*
*      IA=JA=IB=JB= 1
      NRHS = 1
*      NQRHS = 1
*
* LOCr
      NP = 1
* LOCc
      NQ = NB
*      NQRHS = NB
*
*    ( MMIN )
*
      IPDL = 0
      IPD = 0
      IPDU = 0
      IPE = 0
*
*    ()   B
      IPB = 1
*
      IF( NAME .NE. 'PZDTSV' ) GOTO 1
*
*   ,    PZDTSV
*
      LWORK = (12*NPCOL + 3*NB) +
     $        MAX(10*NPCOL + 4*NRHS, 8*NPCOL)
*
* *NQRHS
*       
*
      IPDL = IPB + NB*NRHS
      IPD = IPDL + NB
      IPDU = IPD + NB
*
      IPWOR = IPDU + NB
      GO TO 3
*
    1 IF( NAME .NE. 'PZPTSV' ) GOTO 10
*
*   ,    PZPTSV
*
      LWORK = (12*NPCOL + 3*NB) +
     $        MAX((10 + 2*MIN(100,NRHS))*NPCOL + 4*NRHS, 8*NPCOL)
*
*      
*  
*
      IPD = IPB + NB*NRHS
      IPE = IPD + NB
      IPWOR = IPE + NB
***
    3 IPW = IPWOR + LWORK
*
*     PZLAPRNT  .
*
      WORKSIZ = MAX( NB, NP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NPROCS
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
         WRITE( NPR, FMT = 9993 )NB
         WRITE( NPR, FMT = * )'   IPB,  IPWOR,  IPW,  MMIN' 
         WRITE( NPR, FMT = 9994 )IPB, IPWOR,  IPW, MMIN
         WRITE( NPR, FMT = * )'   IPDL,  IPD,    IPDU,  IPE'
         WRITE( NPR, FMT = 9994 )IPDL, IPD, IPDU,  IPE
         WRITE( NPR, FMT = 9991 )LWORK
*
 9991 FORMAT( /'LWORK =' I5 //)
 9994 FORMAT( / 5I7 //)
*
   10 CONTINUE
*
 9992 FORMAT( / '      A X = B',
     $      '    ', A7/ )
 9998 FORMAT( /'     A ',I2,' *',I2,',',
     $       '    ',I2 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'     '/)
 9993 FORMAT( /'     ( )',
     $       ' NB = ',I2 // '     '/)
      RETURN
      END
